/*

  File:     mpt.h
  Author:   EID
  Date:     July 2005

*/

#ifdef MPTDLL_EXPORTS
#define MPT_API
#else
#define MPT_API __declspec(dllimport)
#endif

#include <windows.h>
#include <setupapi.h>

#ifdef __cplusplus
extern "C" {
#endif

typedef struct
{
	HANDLE							 deviceHandle;
	PSP_INTERFACE_DEVICE_DETAIL_DATA deviceDetail;
	unsigned int					 deviceIndex;
} MptDeviceInformation;


MPT_API void __stdcall InitMptLibraries();

MPT_API void __stdcall SetDataBitMask(MptDeviceInformation* deviceInformation,
				 unsigned char portNumber,
				 unsigned char bitMask,
				 unsigned char value);
                 
MPT_API void __stdcall SetDataBit(MptDeviceInformation* deviceInformation,
				 unsigned char portNumber,
				 unsigned char bitNumber,
				 unsigned char value);

MPT_API void __stdcall SetPullupBit(MptDeviceInformation* deviceInformation,
				   unsigned char portNumber,
				   unsigned char bitNumber,
				   unsigned char value);

MPT_API void __stdcall SetISink(MptDeviceInformation* deviceInformation,
			   unsigned char portNumber,
			   unsigned char bitNumber,
			   unsigned char value);

MPT_API unsigned
char  __stdcall ReadDataBit(MptDeviceInformation* deviceInformation,
				  unsigned char portNumber,
			     unsigned char bitNumber);

MPT_API HANDLE __stdcall OpenFirstMptDevice(MptDeviceInformation* mptDeviceInformation);

MPT_API HANDLE __stdcall OpenNextMptDevice(MptDeviceInformation* lastMptDeviceInformation,
							 MptDeviceInformation* nextMptDeviceInformation);

MPT_API void __stdcall CloseMptDevice(MptDeviceInformation* mptDeviceInformation);

#ifdef __cplusplus
}
#endif
